/*
 *	Praktikum III IF3230
 * ================================
 *	13511001 - Thea Olivia
 *	13511025 - Lubis Sucipto
 *
 */

#include <omp.h>
#include <mpi.h>
#include <iostream>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <limits.h>
#include <string.h>
#include "random.c"

using namespace std;

// insertion sort
void insertionSort(int array[], int n) {
        int c, d, t;

	#pragma omp parallel for insertion(sort_insertion)
        for (c = 1 ; c <= n - 1; c++) {
                d = c;

                while ( d > 0 && array[d] < array[d-1]) {
                        t          = array[d];
                        array[d]   = array[d-1];
                        array[d-1] = t;

                        d--;
                 }
         }
}

// meng-generate integer random yang unik
void random(){
	randomz();
}

int main(int argc, char *argv[]){

	MPI_Init( &argc, &argv);
	
	int world_rank;
	MPI_Comm_rank(MPI_COMM_WORLD, &world_rank);
	int world_size;
	MPI_Comm_size(MPI_COMM_WORLD, &world_size);

	int * compl_arr;
	int i,j;
		int num_elmts;

	if (world_rank==0){
		scanf("%d",&num_elmts);

		compl_arr = (int*) malloc(num_elmts*sizeof(int));

		//random elemen
		randomarr(compl_arr,num_elmts);

	}

	//waktu
	double total_time = 0;
	MPI_Barrier(MPI_COMM_WORLD);
	total_time -= MPI_Wtime();

	//bagi-bagi
	int * num_elmts_in_buckets;
	int * buckets_bin;
	int ** buckets;

	if (world_rank==0){
		num_elmts_in_buckets = (int*) malloc(world_size*sizeof(int));
		buckets = (int**) malloc(world_size*sizeof(int*));
		buckets_bin = (int*) malloc(world_size*sizeof(int));

		for (i=0;i<world_size;i++) buckets_bin[i]=num_elmts*(i+1)/world_size;

		for (i=0;i<world_size;i++){ num_elmts_in_buckets[i]=0; buckets[i]=malloc(num_elmts*sizeof(int));}

		for (i=0;i<num_elmts;i++){
			for (j=0;j<world_size;j++){
				if (compl_arr[i]<=buckets_bin[j]){
					buckets[j][num_elmts_in_buckets[j]]=compl_arr[i];
					num_elmts_in_buckets[j]++;
					break;
				}
			}
		}

		for (i=1;i<world_size;i++){
			MPI_Send(&num_elmts_in_buckets[i],1,MPI_INT,i,1,MPI_COMM_WORLD);
			MPI_Send(buckets[i],num_elmts_in_buckets[i],MPI_INT,i,2,MPI_COMM_WORLD);
		}
	}

	MPI_Status recv_status;

	int num_elmts_in_this_bucket;
	if (world_rank==0)
		num_elmts_in_this_bucket=num_elmts_in_buckets[0];
	else
		MPI_Recv(&num_elmts_in_this_bucket,1,MPI_INT,0,1,MPI_COMM_WORLD,&recv_status);

	int * loc_arr = (int*) malloc(num_elmts_in_this_bucket*sizeof(int));
	if (world_rank==0)
		memcpy(loc_arr,buckets[0],num_elmts_in_this_bucket*sizeof(int));
	else
		MPI_Recv(loc_arr,num_elmts_in_this_bucket,MPI_INT,0,2,MPI_COMM_WORLD,&recv_status);

	sort(loc_arr, num_elmts_in_this_bucket);

	MPI_Barrier(MPI_COMM_WORLD);
	total_time +=MPI_Wtime();

	int compl_arr_i;
	if (world_rank==0){
		memcpy(compl_arr,loc_arr,num_elmts_in_this_bucket*sizeof(int));
		compl_arr_i=num_elmts_in_this_bucket;
		for (i=1;i<world_size;i++){
			MPI_Recv(&compl_arr[compl_arr_i],num_elmts_in_buckets[i],MPI_INT,i,2,MPI_COMM_WORLD,&recv_status);
			compl_arr_i+=num_elmts_in_buckets[i];
		}
	}else
		MPI_Send(loc_arr, num_elmts_in_this_bucket, MPI_INT, 0, 2, MPI_COMM_WORLD);
	free(loc_arr);

	if (world_rank==0){
		printf("waktu : %f\n", total_time);
		free(num_elmts_in_buckets);
		for (i=0;i<world_size;i++)
			free(buckets[i]);
		free(buckets);
		free(buckets_bin);
		free(compl_arr);
	}

	MPI_Finalize();
	return 0;
}
